import State from "./DocumentState/State";
import Draft from "./States/Draft";

class UserDocument {
  private _state!: State;

  private _currentUser: string;

  constructor(user: string) {
    this._currentUser = user;
    this.changeState(new Draft());
  }

  public changeState(state: State): void {
    this._state = state;
    this._state.setDocument(this);
  }

  get currentUser(): string {
    return this._currentUser;
  }

  public sendForModeration(): void {
    this._state.moderate();
  }

  public submitForPublication(): void {
    this._state.publish();
  }

  public sendForDraft(): void {
    this._state.draft();
  }
}

export default UserDocument;
